/*
   DynAPI Distribution
   Cookie functions

   The DynAPI Distribution is distributed under the terms of the GNU LGPL license.
*/ 

/* to-do: make a Cookie object that saves multiple values into one cookie that can be parsed out later
	example:
		var c = new Cookie('mycookieset');
		c.set('name','MyName');
		c.set('array',[1,2,3]);
		
		var c = dynapi.functions.getCookie('mycookieset');
		var name = c.get('name');
		var array = c.get('array');
		array[array.length] = 4;
		c.set('name',name+' MyLastName');
		c.set('array',array);
*/

function Cookie() {
	this.inherit('DynObject');
}
dynapi.setPrototype('Cookie','DynObject');

dynapi.functions.setCookie = function(name,value,days) {
	if (days) {
		var date=new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires="; expires="+date.toGMTString();
	} 
	else expires = "";
	dynapi.frame.document.cookie = name+"="+value+expires+"; path=/";
};
dynapi.functions.getCookie = function(name) {
	var nameEQ = name+"=";
	var ca = dynapi.frame.document.cookie.split(';');
	for(var i=0;i<ca.length;i++) {
		var c=ca[i];
		while (c.charAt(0)==' ') c=c.substring(1,c.length);
		if (c.indexOf(nameEQ)==0) return c.substring(nameEQ.length,c.length);
	}
	return null;
};
dynapi.functions.deleteCookie = function(name) {
	dynapi.functions.setCookie(name,"",-1);
};
